#!/usr/bin/perl
#$Id: elchemea_updater.pl,v 1.7 2016/01/19 12:45:09 sofc Exp $
use strict;
use warnings;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request;
use HTTP::Response;
use HTML::LinkExtor; # allows you to extract the links off of an HTML page.
use SemaforeFile;
use ElchemeaHeader;
use Elchemea;
use ElchemeaUser;
my $proxy = &Elchemea::get_cnfig_value('global','proxy');
my $debug = 0;
my $user = $<;
if ($user != 0)
{
    print "must be root to run!\n";
    if (!$debug)
    {
        exit 0;
    }
}

my $hostfile = SemaforeFile->new('/home/elchemea/update_host.txt');
my @lines = $hostfile->readlines();
die "No host information found!" unless (@lines > 2);
my $host = $lines[0];
my $path = $lines[1];
my $file = $lines[2];
my $keyfile = 'http://'.$host.$path.$file;
my $local_build = SemaforeFile->new('/home/elchemea/build');
$local_build->open_read;
my $local_version = $Elchemea::VERSION.'-'.$local_build->readline;
$local_build->close;
chomp $local_version;

my $browser = LWP::UserAgent->new();

if ($proxy)
{
    $ENV{HTTP_proxy} = $proxy;
    $browser->env_proxy;
}

$browser->timeout(10);

my $t = localtime();
print $t,"\n";
print "Fetching version from $keyfile\n";
my $request = HTTP::Request->new(GET => $keyfile);
my $response = $browser->request($request);
if ($response->is_error()) {
    printf "%s\n", $response->status_line;
    exit;
}
my $content = $response->content();
chomp $content;
if ($content eq $local_version)
{
    print "Elchemea system up to date\n";
    exit;
}
if ($content =~ /^([\d\.]+)/)
{
    my $v = $1;
    my $f = 'http://'.$host.$path.'Elchemea-'.$v.'.tgz';
    print "Fetching new version from $f using wget\n";
    my $cmd = '/usr/bin/wget '.$f.' -O /root/Elchemea-'.$v.'.tgz';
    if ($proxy)
    {
	$cmd .= ' -e use_proxy=yes -e http_proxy='.$proxy;
    }
    system($cmd);
    chdir '/root/';
    $cmd = '/bin/tar -xzf Elchemea-'.$v.'.tgz';
    print "Extracting new source.....\n";
    system($cmd);
    chdir 'elchemea/';
    system('make');
    if ($? == -1)
    {
	print "Make failed! aborting update.\n";
	exit 1;
    }
    system('make update');
    if ($? == -1)
    {
	print "Make update failed! System possibly in an incomplete/undefined state!.\n";
	exit 1;
    }
    my $string = "Elchemea system updated to version $content";
    my $passwdlock = $homedir.'pwd.lock';
    my $passwdfile = SemaforeFile->new($homedir.'users.txt',$passwdlock);
    my @list = $passwdfile->readlines();
    foreach (@list)
    {
	if (/^(\w+)\:/)
	{
	    my $user = ElchemeaUser->new($1);
	    next unless $user->session;
	    eval {
		$user->proglog($string);
	    };
	    if ($@)
	    {
		### Errors in proglog considered non-fatal ###
		warn @$;
	    }
	}
    }
    print "\nDone udating Elchemea!\n\n";
}
