#!/usr/bin/perl
#$Id: printport-server.pl,v 1.2 2010/10/19 11:29:46 sofc Exp $
use strict;
use Socket;
use Elchemea;
use SemaforeFile;
our $this_host = "localhost";
our $user      = "nobody";
our $lprport = '/usr/local/bin/lprport';
exit unless (get_config_value('equipment','parallel_port_controler')=~ /yes/i);
$SIG{"CHLD"} = "IGNORE";
my $debug = 0;
unless ( our $uid = ( getpwnam($user) )[2] ) 
{
    die "Attempt to run server as non-existent or superuser\n";
}


our $f = SemaforeFile->new('/var/printport_status.txt','/var/printport_lock');

our $str;
&init();


# Initialize C structure
#
our $port      = 1234;
our $server_addr   = ( gethostbyname($this_host) )[4];
our $server_struct = pack( "S n a4 x8", AF_INET, $port, $server_addr );
print "Server address: $server_addr\n" if ($debug);

# Set up socket
#
our $proto = ( getprotobyname("tcp") )[2];
socket( SOCK, PF_INET, SOCK_STREAM, $proto )
  || die "Failed to initialize socket: $!\n";
# Bind to address/port and set up pending queue
#
setsockopt( SOCK, SOL_SOCKET, SO_REUSEADDR, 1 )
  || die "setsockopt() failed: $!\n";
bind( SOCK, $server_struct ) || die "bind() failed: $!\n";
listen( SOCK, SOMAXCONN ) || die "listen() failed: $!\n";

# Deal with requests
#
our $remote_host;
for ( ; ; ) {

    # Grab next pending request
    #
    $remote_host = accept( NEWSOCK, SOCK );
    die "accept() error: $!\n" unless ($remote_host);

    # We're the parent if fork() returns non-zero
    #
    last unless ( fork() );
    close(NEWSOCK);
}
# *** If we've fallen out of the loop, then we're the child. ***

# Close master socket
#
close(SOCK);

# Resolve hostname of remote machine before calling chroot()
#
our $raw_addr = ( unpack( "S n a4 x8", $remote_host ) )[2];
our $dot_addr = join ( ".", unpack( "C4", $raw_addr ) );
our $name = ( gethostbyaddr( $raw_addr, AF_INET ) )[0];
# Read client request and get $path
#

our %cmdlst = ();
$cmdlst{'set'} = 'set';
$cmdlst{'read'} = 'read';
$cmdlst{'debug'} = 'debug';
our @acmd = ();
our $cmd = undef;
our $i = 0;
our $path = '';
my $st = <NEWSOCK>;
chomp($st);
@acmd = split(' ',$st);
if ( defined $cmdlst{$acmd[0]})
{
    $cmd = $cmdlst{$acmd[0]};
} 
# Print a line of logging info to STDOUT
#
my $ltime = localtime;
print "$ltime\t$dot_addr\t$name\t$path\t$cmd\n" if ($debug);

my $res = 0;
if ($cmd) 
{
    if ($cmd eq 'debug')
    {
	if ($debug)
	{
	    $debug = 0;
	}
	else
	{
	    $debug = 1;
	}
    }
    if ($cmd eq 'set')
    {
	my $ch = $acmd[1];
	$ch = 7 if ($ch > 7);
	$ch = 0 if ($ch < 0);
	my $status = $acmd[2];
	$f->lock_ex;
	my @l = $f->readlines;
	$str = $l[0];
	$str += 0;
	&set_str($ch,$status);
	my $lpr = get_config_value('equipment','parallel_port');
	my $cmd = "$lprport $str > $lpr";
	system($cmd);
	$f->writeline($str);
	$f->unlock;
	print NEWSOCK $str,"\n";
    }
    if ($cmd eq 'read')
    {
	my $ch = $acmd[1];
	$ch = 7 if ($ch > 7);
	$ch = 0 if ($ch < 0);
	$f->lock_sh;
	my @l = $f->readlines;
	$f->unlock;
	$str = $l[0];
	$str += 0;
	$res = 1 if ($str & 2**$ch);
	print NEWSOCK $res,"\n";
    }
}
close(NEWSOCK);

sub set_str($$)
{
    my @arr = ();
    for (my $x = 0; $x < 8; $x++)
    {
	$arr[$x] = $str & 2**$x;
    }
    $arr[$_[0]] = 0;
    $arr[$_[0]] = 1 if ($_[1]);
    my $y = 0;
    for (my $x = 0; $x < 8; $x++)
    {
	$y += 2**$x if ($arr[$x]); 
    }
    $str = $y;
}

sub init
{
    exit unless ($f->lock_ex_nb);
    my @l = $f->readlines();
    $str = $l[0];
    if ($str)
    {
	$str += 0;
    }
    else
    {
	$str = 0;
    }
    my $lpr = get_config_value('equipment','parallel_port');
    my $cmd = "$lprport $str > $lpr";
    system($cmd);
    $f->unlock;
}
